schema_name   : args
schema_version: 1.0
schema_type   : peripheral

hdl_library_name       : Packetiser
hdl_library_description: "Generation of IPv4 UDP packets from signal processing output"

peripherals:
  - peripheral_name        : Packetiser
    peripheral_description : "Registers associated with Generating IPv4 UDP packets"
    slave_ports:
      - slave_name        : Param
        slave_type        : RAM
        number_of_slaves  : 1
        slave_description : "Data for Ethernet, IPv4, UDP frame, PSR METADATA, Control"
        fields            :
          - - field_name        : Parameter_data
              width             : 32
              user_width        : 32
              access_mode       : RW
              number_of_fields  : 8192
              interface         : simple
              reset_value       : 0
              field_description : "One address space as per below, with partial fields assume lower bits used.
                                  0.ethernet_config.dst_mac(31 downto 0)
                                  1.ethernet_config.dst_mac(47 downto 32)
                                  2.ethernet_config.src_mac(31 downto 0)
                                  3.ethernet_config.src_mac(47 downto 32)
                                  4.ethernet_config.eth_type
                                  5.ipv4_config.version(31 : 28)          NO LONGER WRABLE, 
                                    ipv4_config.header_length(27 : 24)    NO LONGER WRABLE, 
                                    ipv4_config.type_of_service(23 : 16), 
                                    ipv4_config.total_length(15 : 0)      NO LONGER WRABLE,
                                  6.ipv4_config.id(31 : 16), 
                                    ipv4_config.ip_flags(15 : 13)         NO LONGER WRABLE, 
                                    ipv4_config.fragment_off(12 : 0)      NO LONGER WRABLE
                                  7.ipv4_config.TTL (31 : 24), 
                                    ipv4_config.protocol (23 : 16), 
                                    ipv4_config.header_chk_sum (15 : 0)   NO LONGER WRABLE
                                  8.ipv4_config.src_addr
                                  9.ipv4_config.dst_addr
                                  10.udp_config.src_port(31 : 16), udp_config.dst_port(15 : 0)
                                  11.udp_config.length(31 : 16), udp_config.checksum(15 : 0)  NO LONGER WRABLE,
                                  12.PsrPacket_config.packet_sequence_number(63 downto 32)
                                  13.PsrPacket_config.packet_sequence_number(31 downto 0)
                                  14.PsrPacket_config.timestamp_attoseconds(63 downto 32)     NO LONGER WRABLE
                                  15.PsrPacket_config.timestamp_attoseconds(31 downto 0)      NO LONGER WRABLE
                                  16.PsrPacket_config.timestamp_seconds                       NO LONGER WRABLE
                                  17.PsrPacket_config.channel_seperation
                                  18.PsrPacket_config.first_channel_frequency(63 downto 32)   NO LONGER WRABLE
                                  19.PsrPacket_config.first_channel_frequency(31 downto 0)    NO LONGER WRABLE
                                  20.PsrPacket_config.scale_1                                 NO LONGER WRABLE
                                  21.PsrPacket_config.scale_2
                                  22.PsrPacket_config.scale_3
                                  23.PsrPacket_config.scale_4
                                  24.PsrPacket_config.first_channel_number                    NO LONGER WRABLE
                                  25.PsrPacket_config.channels_per_packet                     NO LONGER WRABLE
                                  26.PsrPacket_config.valid_channels_per_packet               NO LONGER WRABLE
                                  27.PsrPacket_config.number_of_time_samples                  NO LONGER WRABLE
                                  28.PsrPacket_config.beam_number                             NO LONGER WRABLE
                                  29.PsrPacket_config.magic_word
                                  30.PsrPacket_config.packet_destination
                                  31.PsrPacket_config.data_precision
                                  32.PsrPacket_config.number_of_power_samples_averaged
                                  33.PsrPacket_config.number_of_time_samples_weight
                                  34.PsrPacket_config.oversampling_ratio_numerator            NO LONGER WRABLE
                                  35.PsrPacket_config.oversampling_ratio_denominator          NO LONGER WRABLE
                                  36.PsrPacket_config.beamformer_version                      NO LONGER WRABLE
                                  37.PsrPacket_config.scan_id(63 downto 32)
                                  38.PsrPacket_config.scan_id(31 downto 0)
                                  39.PsrPacket_config.offset_1
                                  40.PsrPacket_config.offset_2
                                  41.PsrPacket_config.offset_3
                                  42.PsrPacket_config.offset_4
                                  43.Packet generator number of packets to send before stopping when that option set
                                  44.Packet generator number of cycles between packets,       default = 0x00000200
                                  45.Packet generator number of beams to produce, ie 0 to 7 then start again.
                                  -- BEAM number rewrite, if Beam 0 is passed from the Beamformer, the value in address 512 will be inject into the PSR metad data.
                                  -- 513 will deal with Beam 1 and so on.
                                  -- The width of the ARGs data bus is 32 bits, but only 16 bits of value will be preserved on a software write.
                                  -- All 512 positions supported for PSS.
                                  512. Beam 0 rewrite value
                                  513. Beam 1 rewrite value
                                  514. Beam 2 rewrite value
                                  515. Beam 3 rewrite value
                                  ...
                                  527. Beam 15 rewrite value
                                  1024-2047 Reads to this space will return 0xBADC0FEE. Writes will not be stored.
                                  ADDRESSES 
                                  2048-4095 First chan freq redir ram 1 - lower 32 bits of 64 bit first channel freq
                                  4096-6143 First chan freq redir ram 2 - upper 32 bits of 64 bit first channel freq
                                            2 RAMS by 32 output to give a 64 bit vector for first_channel_freq. 
                                            This takes in the virtual channel (2048 postisions)
                                            One entry for each PST packet (containing 24 PST channels) that will be output.
                                            The bus from the Beamformer presents the freq indexs from zero in the following structure
                                            bits(3:0) index the fine channel, and count from 0 to 8 inclusive for the 9 different output packets per LFAA coarse channel, 
                                            bits(11:4) index the coarse channel
                                  6144 - 8191 First chan number
                                            Takes in the virtual channel bus (11 bits) to return actual channel number (32-bit)
                                  8k-16k unused.
                                  "
      #########################################################################################                            
      - slave_name        : Packetiser_Ctrl
        slave_type        : reg
        number_of_slaves  : 1
        slave_description : "Control vector for all stream Statistics for all"
        dual_clock        : false
        fields            :
          - - field_name        : Control_vector
              width             : 8
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Stream
                                  Bit 0 - Enable Packetiser - This will load all the variables for Ethernet/UDP/IPv4 etc and Packet Generator (testmode) controls
                                  Bit 1 - Enable Packet Generator
                                  Bit 2 - Use Packet Generator number of runs parameter
                                  Bit 3 - Use default values for parameters
                                  Bits 4-7 reserved
                                  "
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc_valid
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Received expected number of bytes from Signal Processing Logic / Test Pattern Gen"
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc_invalid
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Did not receive expected number of bytes from Signal Processing Logic / Test Pattern Gen"
         #################################
          - - field_name        : Stats_Packets_RX_SM_off
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Data sent to Packetiser sent while SM not running, effectively lost data"
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Packets sent to 100G interface"
      #################################################################

  - peripheral_name        : Packetiser_2
    peripheral_description : "Registers associated with Generating IPv4 UDP packets"
    slave_ports:
      - slave_name        : Param
        slave_type        : RAM
        number_of_slaves  : 1
        slave_description : "Data for Ethernet, IPv4, UDP frame, PSR METADATA, Control"
        fields            :
          - - field_name        : Parameter_data
              width             : 32
              user_width        : 32
              access_mode       : RW
              number_of_fields  : 8192
              interface         : simple
              reset_value       : 0
              field_description : "One address space as per below, with partial fields assume lower bits used.
                                  0.ethernet_config.dst_mac(31 downto 0)
                                  1.ethernet_config.dst_mac(47 downto 32)
                                  2.ethernet_config.src_mac(31 downto 0)
                                  3.ethernet_config.src_mac(47 downto 32)
                                  4.ethernet_config.eth_type
                                  5.ipv4_config.version(31 : 28)          NO LONGER WRABLE, 
                                    ipv4_config.header_length(27 : 24)    NO LONGER WRABLE, 
                                    ipv4_config.type_of_service(23 : 16), 
                                    ipv4_config.total_length(15 : 0)
                                  6.ipv4_config.id(31 : 16), 
                                    ipv4_config.ip_flags(15 : 13)         NO LONGER WRABLE, 
                                    ipv4_config.fragment_off(12 : 0)      NO LONGER WRABLE
                                  7.ipv4_config.TTL (31 : 24), 
                                    ipv4_config.protocol (23 : 16), 
                                    ipv4_config.header_chk_sum (15 : 0)   NO LONGER WRABLE
                                  8.ipv4_config.src_addr
                                  9.ipv4_config.dst_addr
                                  10.udp_config.src_port(31 : 16), udp_config.dst_port(15 : 0)
                                  11.udp_config.length(31 : 16), udp_config.checksum(15 : 0)
                                  12.PsrPacket_config.packet_sequence_number(63 downto 32)
                                  13.PsrPacket_config.packet_sequence_number(31 downto 0)
                                  14.PsrPacket_config.timestamp_attoseconds(63 downto 32)     NO LONGER WRABLE
                                  15.PsrPacket_config.timestamp_attoseconds(31 downto 0)      NO LONGER WRABLE
                                  16.PsrPacket_config.timestamp_seconds                       NO LONGER WRABLE
                                  17.PsrPacket_config.channel_seperation
                                  18.PsrPacket_config.first_channel_frequency(63 downto 32)   NO LONGER WRABLE
                                  19.PsrPacket_config.first_channel_frequency(31 downto 0)    NO LONGER WRABLE
                                  20.PsrPacket_config.scale_1                                 NO LONGER WRABLE
                                  21.PsrPacket_config.scale_2
                                  22.PsrPacket_config.scale_3
                                  23.PsrPacket_config.scale_4
                                  24.PsrPacket_config.first_channel_number                    NO LONGER WRABLE
                                  25.PsrPacket_config.channels_per_packet                     NO LONGER WRABLE
                                  26.PsrPacket_config.valid_channels_per_packet               NO LONGER WRABLE
                                  27.PsrPacket_config.number_of_time_samples                  NO LONGER WRABLE
                                  28.PsrPacket_config.beam_number                             NO LONGER WRABLE
                                  29.PsrPacket_config.magic_word
                                  30.PsrPacket_config.packet_destination
                                  31.PsrPacket_config.data_precision
                                  32.PsrPacket_config.number_of_power_samples_averaged
                                  33.PsrPacket_config.number_of_time_samples_weight
                                  34.PsrPacket_config.oversampling_ratio_numerator            NO LONGER WRABLE
                                  35.PsrPacket_config.oversampling_ratio_denominator          NO LONGER WRABLE
                                  36.PsrPacket_config.beamformer_version                      NO LONGER WRABLE
                                  37.PsrPacket_config.scan_id(63 downto 32)
                                  38.PsrPacket_config.scan_id(31 downto 0)
                                  39.PsrPacket_config.offset_1
                                  40.PsrPacket_config.offset_2
                                  41.PsrPacket_config.offset_3
                                  42.PsrPacket_config.offset_4
                                  43.Packet generator number of packets to send before stopping when that option set
                                  44.Packet generator number of cycles between packets,       default = 0x00000200
                                  45.Packet generator number of beams to produce, ie 0 to 7 then start again.
                                  -- BEAM number rewrite, if Beam 0 is passed from the Beamformer, the value in address 512 will be inject into the PSR metad data.
                                  -- 513 will deal with Beam 1 and so on.
                                  -- The width of the ARGs data bus is 32 bits, but only 8 bits of value will be preserved on a software write.
                                  -- Only 16 address apply to this 512 -> +16
                                  512. Beam 0 rewrite value
                                  513. Beam 1 rewrite value
                                  514. Beam 2 rewrite value
                                  515. Beam 3 rewrite value
                                  ...
                                  527. Beam 15 rewrite value
                                  1024-2047 Reads to this space will return 0xBADC0FEE. Writes will not be stored.
                                  ADDRESSES 
                                  2048-4095 First chan freq redir ram 1 - lower 32 bits of 64 bit first channel freq
                                  4096-6143 First chan freq redir ram 2 - upper 32 bits of 64 bit first channel freq
                                            2 RAMS by 32 output to give a 64 bit vector for first_channel_freq. 
                                            This takes in the virtual channel (2048 postisions)
                                            One entry for each PST packet (containing 24 PST channels) that will be output.
                                            The bus from the Beamformer presents the freq indexs from zero in the following structure
                                            bits(3:0) index the fine channel, and count from 0 to 8 inclusive for the 9 different output packets per LFAA coarse channel, 
                                            bits(11:4) index the coarse channel
                                  6144 - 8191 First chan number
                                            Takes in the virtual channel bus (11 bits) to return actual channel number (32-bit)
                                  8k-16k unused.
                                  "
      #########################################################################################
      - slave_name        : Packetiser_Ctrl
        slave_type        : reg
        number_of_slaves  : 1
        slave_description : "Control vector for all stream Statistics for all"
        dual_clock        : false
        fields            :
          - - field_name        : Control_vector
              width             : 8
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Stream
                                  Bit 0 - Enable Packetiser - This will load all the variables for Ethernet/UDP/IPv4 etc and Packet Generator (testmode) controls
                                  Bit 1 - Enable Packet Generator
                                  Bit 2 - Use Packet Generator number of runs parameter
                                  Bit 3 - Use default values for parameters
                                  Bits 4-7 reserved
                                  "
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc_valid
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Received expected number of bytes from Signal Processing Logic / Test Pattern Gen"
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc_invalid
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Did not receive expected number of bytes from Signal Processing Logic / Test Pattern Gen"
         #################################
          - - field_name        : Stats_Packets_RX_SM_off
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Data sent to Packetiser sent while SM not running, effectively lost data"
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Packets sent to 100G interface"
      #################################################################

  - peripheral_name        : Packetiser_3
    peripheral_description : "Registers associated with Generating IPv4 UDP packets"
    slave_ports:
      - slave_name        : Param
        slave_type        : RAM
        number_of_slaves  : 1
        slave_description : "Data for Ethernet, IPv4, UDP frame, PSR METADATA, Control"
        fields            :
          - - field_name        : Parameter_data
              width             : 32
              user_width        : 32
              access_mode       : RW
              number_of_fields  : 8192
              interface         : simple
              reset_value       : 0
              field_description : "One address space as per below, with partial fields assume lower bits used.
                                  0.ethernet_config.dst_mac(31 downto 0)
                                  1.ethernet_config.dst_mac(47 downto 32)
                                  2.ethernet_config.src_mac(31 downto 0)
                                  3.ethernet_config.src_mac(47 downto 32)
                                  4.ethernet_config.eth_type
                                  5.ipv4_config.version(31 : 28)          NO LONGER WRABLE, 
                                    ipv4_config.header_length(27 : 24)    NO LONGER WRABLE, 
                                    ipv4_config.type_of_service(23 : 16), 
                                    ipv4_config.total_length(15 : 0)
                                  6.ipv4_config.id(31 : 16), 
                                    ipv4_config.ip_flags(15 : 13)         NO LONGER WRABLE, 
                                    ipv4_config.fragment_off(12 : 0)      NO LONGER WRABLE
                                  7.ipv4_config.TTL (31 : 24), 
                                    ipv4_config.protocol (23 : 16), 
                                    ipv4_config.header_chk_sum (15 : 0)   NO LONGER WRABLE
                                  8.ipv4_config.src_addr
                                  9.ipv4_config.dst_addr
                                  10.udp_config.src_port(31 : 16), udp_config.dst_port(15 : 0)
                                  11.udp_config.length(31 : 16), udp_config.checksum(15 : 0)
                                  12.PsrPacket_config.packet_sequence_number(63 downto 32)
                                  13.PsrPacket_config.packet_sequence_number(31 downto 0)
                                  14.PsrPacket_config.timestamp_attoseconds(63 downto 32)     NO LONGER WRABLE
                                  15.PsrPacket_config.timestamp_attoseconds(31 downto 0)      NO LONGER WRABLE
                                  16.PsrPacket_config.timestamp_seconds                       NO LONGER WRABLE
                                  17.PsrPacket_config.channel_seperation
                                  18.PsrPacket_config.first_channel_frequency(63 downto 32)   NO LONGER WRABLE
                                  19.PsrPacket_config.first_channel_frequency(31 downto 0)    NO LONGER WRABLE
                                  20.PsrPacket_config.scale_1                                 NO LONGER WRABLE
                                  21.PsrPacket_config.scale_2
                                  22.PsrPacket_config.scale_3
                                  23.PsrPacket_config.scale_4
                                  24.PsrPacket_config.first_channel_number                    NO LONGER WRABLE
                                  25.PsrPacket_config.channels_per_packet                     NO LONGER WRABLE
                                  26.PsrPacket_config.valid_channels_per_packet               NO LONGER WRABLE
                                  27.PsrPacket_config.number_of_time_samples                  NO LONGER WRABLE
                                  28.PsrPacket_config.beam_number                             NO LONGER WRABLE
                                  29.PsrPacket_config.magic_word
                                  30.PsrPacket_config.packet_destination
                                  31.PsrPacket_config.data_precision
                                  32.PsrPacket_config.number_of_power_samples_averaged
                                  33.PsrPacket_config.number_of_time_samples_weight
                                  34.PsrPacket_config.oversampling_ratio_numerator            NO LONGER WRABLE
                                  35.PsrPacket_config.oversampling_ratio_denominator          NO LONGER WRABLE
                                  36.PsrPacket_config.beamformer_version                      NO LONGER WRABLE
                                  37.PsrPacket_config.scan_id(63 downto 32)
                                  38.PsrPacket_config.scan_id(31 downto 0)
                                  39.PsrPacket_config.offset_1
                                  40.PsrPacket_config.offset_2
                                  41.PsrPacket_config.offset_3
                                  42.PsrPacket_config.offset_4
                                  43.Packet generator number of packets to send before stopping when that option set
                                  44.Packet generator number of cycles between packets,       default = 0x00000200
                                  45.Packet generator number of beams to produce, ie 0 to 7 then start again.
                                  -- BEAM number rewrite, if Beam 0 is passed from the Beamformer, the value in address 512 will be inject into the PSR metad data.
                                  -- 513 will deal with Beam 1 and so on.
                                  -- The width of the ARGs data bus is 32 bits, but only 8 bits of value will be preserved on a software write.
                                  -- Only 16 address apply to this 512 -> +16
                                  512. Beam 0 rewrite value
                                  513. Beam 1 rewrite value
                                  514. Beam 2 rewrite value
                                  515. Beam 3 rewrite value
                                  ...
                                  527. Beam 15 rewrite value
                                  1024-2047 Reads to this space will return 0xBADC0FEE. Writes will not be stored.
                                  ADDRESSES 
                                  2048-4095 First chan freq redir ram 1 - lower 32 bits of 64 bit first channel freq
                                  4096-6143 First chan freq redir ram 2 - upper 32 bits of 64 bit first channel freq
                                            2 RAMS by 32 output to give a 64 bit vector for first_channel_freq. 
                                            This takes in the virtual channel (2048 postisions)
                                            One entry for each PST packet (containing 24 PST channels) that will be output.
                                            The bus from the Beamformer presents the freq indexs from zero in the following structure
                                            bits(3:0) index the fine channel, and count from 0 to 8 inclusive for the 9 different output packets per LFAA coarse channel, 
                                            bits(11:4) index the coarse channel
                                  6144 - 8191 First chan number
                                            Takes in the virtual channel bus (11 bits) to return actual channel number (32-bit)
                                  8k-16k unused.
                                  "
      #########################################################################################
      - slave_name        : Packetiser_Ctrl
        slave_type        : reg
        number_of_slaves  : 1
        slave_description : "Control vector for all stream Statistics for all"
        dual_clock        : false
        fields            :
          - - field_name        : Control_vector
              width             : 8
              access_mode       : RW
              reset_value       : 0x0
              field_description : "Stream
                                  Bit 0 - Enable Packetiser - This will load all the variables for Ethernet/UDP/IPv4 etc and Packet Generator (testmode) controls
                                  Bit 1 - Enable Packet Generator
                                  Bit 2 - Use Packet Generator number of runs parameter
                                  Bit 3 - Use default values for parameters
                                  Bits 4-7 reserved
                                  "
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc_valid
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Received expected number of bytes from Signal Processing Logic / Test Pattern Gen"
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc_invalid
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Did not receive expected number of bytes from Signal Processing Logic / Test Pattern Gen"
         #################################
          - - field_name        : Stats_Packets_RX_SM_off
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Data sent to Packetiser sent while SM not running, effectively lost data"
         #################################
          - - field_name        : Stats_Packets_RX_Sig_Proc
              width             : 32
              access_mode       : RO
              reset_value       : 0x0
              field_description : "Packets sent to 100G interface"
      #################################################################
